﻿// created on 01/07/2003 at 22:01
using System;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using J4L.RFax;


	public class FaxTest : System.Windows.Forms.Form ,IFaxStatusListener,IFaxReceiver
	{
		private System.Windows.Forms.Label label;
		private System.Windows.Forms.ComboBox comboDialing;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.TextBox textPort;
		private System.Windows.Forms.Button btnSend;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.ComboBox comboFlowControlCommand;
		private System.Windows.Forms.TextBox textInit;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Button btnReceive;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.RichTextBox textData;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textNumber;
		private System.Windows.Forms.ComboBox comboFlowControl;
			
			
		public FaxTest()
		{
			InitializeComponent();
		}			
			
			void btnSendClick(object sender, System.EventArgs e)
			{
				sendfax();
			}
			
			void btnQuitClick(object sender, System.EventArgs e)
			{
				this.Close();
			}
			
			
	FaxReceiverModem m;
		
	void btnReceiveClick(object sender, System.EventArgs e)
	{
						
    btnQuit.Enabled=false;
    btnSend.Enabled=false;

	this.lblStatus.ForeColor=Color.Blue;

     m=new FaxReceiverModem();
		
  	 m.flowControl=FaxModem.FLOWCONTROL_RTSCTS;
	 m.ATFlowControlRTSCTS=this.comboFlowControlCommand.Text;
	 m.setInitstring(textInit.Text);	
	 m.directBitOrder=true;
	 m.log=true;			
	 m.resolution=FaxModem.RESOLUTION_NORMAL;
	 m.bitRate=FaxModem.BITRATE_9600;
	 m.AtFBOR=true;
			
	 if (this.comboFlowControl.SelectedIndex==1) 
			{ m.flowControl=FaxModem.FLOWCONTROL_XONXOFF;
			  m.ATFlowControlXONXOFF=this.comboFlowControlCommand.Text;	
			}
	 if (this.comboFlowControl.SelectedIndex==2) 
			{m.flowControl=FaxModem.FLOWCONTROL_NONE;
			m.ATFlowControlNone=this.comboFlowControlCommand.Text;
			}
		
	 m.port=this.textPort.Text;

	 // status listener
	 m.listener=this;

     ((FaxReceiverModem) m).faxReceiver=this;
     if (((FaxReceiverModem) m).openReception())  ((FaxReceiverModem) m).waitForFax();

												
	}
	
			
	void btnStopClick(object sender, System.EventArgs e)
	{
				
  		if (m!=null) m.close();

        this.lblStatus.ForeColor=Color.Blue;
        lblStatus.Text="Inactive...";
        btnSend.Enabled=true;
        btnQuit.Enabled=true;
								
	}
			
		void InitializeComponent() {
			this.comboFlowControl = new System.Windows.Forms.ComboBox();
			this.textNumber = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.textData = new System.Windows.Forms.RichTextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btnReceive = new System.Windows.Forms.Button();
			this.btnStop = new System.Windows.Forms.Button();
			this.textInit = new System.Windows.Forms.TextBox();
			this.comboFlowControlCommand = new System.Windows.Forms.ComboBox();
			this.btnQuit = new System.Windows.Forms.Button();
			this.btnSend = new System.Windows.Forms.Button();
			this.textPort = new System.Windows.Forms.TextBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.comboDialing = new System.Windows.Forms.ComboBox();
			this.label = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// comboFlowControl
			// 
			this.comboFlowControl.Items.AddRange(new object[] {
						"RTS/CTS",
						"XON/XOFF",
						"None"});
			this.comboFlowControl.Location = new System.Drawing.Point(152, 32);
			this.comboFlowControl.Name = "comboFlowControl";
			this.comboFlowControl.Size = new System.Drawing.Size(216, 21);
			this.comboFlowControl.TabIndex = 9;
			this.comboFlowControl.Text = "RTS/CTS";
			// 
			// textNumber
			// 
			this.textNumber.Location = new System.Drawing.Point(152, 104);
			this.textNumber.Name = "textNumber";
			this.textNumber.Size = new System.Drawing.Size(216, 20);
			this.textNumber.TabIndex = 12;
			this.textNumber.Text = "**";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 88);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(136, 16);
			this.label4.TabIndex = 5;
			this.label4.Text = "Modem init. string";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 112);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(136, 16);
			this.label5.TabIndex = 6;
			this.label5.Text = "Fax number";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 136);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(136, 16);
			this.label6.TabIndex = 7;
			this.label6.Text = "Dialing";
			// 
			// textData
			// 
			this.textData.DetectUrls = false;
			this.textData.Location = new System.Drawing.Point(16, 160);
			this.textData.Name = "textData";
			this.textData.Size = new System.Drawing.Size(352, 216);
			this.textData.TabIndex = 14;
			this.textData.Text = "Enter text here";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Flow Control";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Flow Control Command";
			// 
			// btnReceive
			// 
			this.btnReceive.Location = new System.Drawing.Point(88, 416);
			this.btnReceive.Name = "btnReceive";
			this.btnReceive.TabIndex = 16;
			this.btnReceive.Text = "Receive";
			this.btnReceive.Click += new System.EventHandler(this.btnReceiveClick);
			// 
			// btnStop
			// 
			this.btnStop.Location = new System.Drawing.Point(200, 416);
			this.btnStop.Name = "btnStop";
			this.btnStop.TabIndex = 17;
			this.btnStop.Text = "Stop";
			this.btnStop.Click += new System.EventHandler(this.btnStopClick);
			// 
			// textInit
			// 
			this.textInit.Location = new System.Drawing.Point(152, 80);
			this.textInit.Name = "textInit";
			this.textInit.Size = new System.Drawing.Size(216, 20);
			this.textInit.TabIndex = 11;
			this.textInit.Text = "ATV1Q0";
			// 
			// comboFlowControlCommand
			// 
			this.comboFlowControlCommand.Items.AddRange(new object[] {
						"-- RtsCts --",
						"AT&K3",
						"AT&\\\\Q3",
						"AT+FLO=2",
						"AT&H1",
						"-- XonXoff --",
						"AT+FLO=1",
						"AT&K4",
						"AT&\\\\Q4",
						""});
			this.comboFlowControlCommand.Location = new System.Drawing.Point(152, 56);
			this.comboFlowControlCommand.Name = "comboFlowControlCommand";
			this.comboFlowControlCommand.Size = new System.Drawing.Size(216, 21);
			this.comboFlowControlCommand.TabIndex = 10;
			this.comboFlowControlCommand.Text = "AT&K3";
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(200, 384);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.TabIndex = 1;
			this.btnQuit.Text = "Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuitClick);
			// 
			// btnSend
			// 
			this.btnSend.Location = new System.Drawing.Point(88, 384);
			this.btnSend.Name = "btnSend";
			this.btnSend.TabIndex = 0;
			this.btnSend.Text = "Send";
			this.btnSend.Click += new System.EventHandler(this.btnSendClick);
			// 
			// textPort
			// 
			this.textPort.Location = new System.Drawing.Point(152, 8);
			this.textPort.Name = "textPort";
			this.textPort.Size = new System.Drawing.Size(216, 20);
			this.textPort.TabIndex = 8;
			this.textPort.Text = "COM3";
			// 
			// lblStatus
			// 
			this.lblStatus.ForeColor = System.Drawing.Color.Red;
			this.lblStatus.Location = new System.Drawing.Point(16, 448);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(352, 23);
			this.lblStatus.TabIndex = 15;
			// 
			// comboDialing
			// 
			this.comboDialing.Items.AddRange(new object[] {
						"Tone",
						"Pulse"});
			this.comboDialing.Location = new System.Drawing.Point(152, 128);
			this.comboDialing.Name = "comboDialing";
			this.comboDialing.Size = new System.Drawing.Size(216, 21);
			this.comboDialing.TabIndex = 13;
			this.comboDialing.Text = "Tone";
			// 
			// label
			// 
			this.label.Location = new System.Drawing.Point(8, 16);
			this.label.Name = "label";
			this.label.Size = new System.Drawing.Size(128, 16);
			this.label.TabIndex = 2;
			this.label.Text = "Port (COM1, COM2 ...)";
			// 
			// FaxTest
			// 
			this.ClientSize = new System.Drawing.Size(384, 478);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
						this.btnStop,
						this.btnReceive,
						this.lblStatus,
						this.textData,
						this.comboDialing,
						this.textNumber,
						this.textInit,
						this.comboFlowControlCommand,
						this.comboFlowControl,
						this.textPort,
						this.label6,
						this.label5,
						this.label4,
						this.label3,
						this.label2,
						this.label,
						this.btnQuit,
						this.btnSend});
			this.Text = "Fax Test";
			this.ResumeLayout(false);
		}
		
		public void faxProgress(int status,int page) {
			
 		 if (status==FaxModem.ST_CLOSE) lblStatus.Text="Closing...";
	  	 if (status==FaxModem.ST_CONNECTING) lblStatus.Text="Connecting...";
	 	 if (status==FaxModem.ST_CONVERT_FIlES) lblStatus.Text="Converting fax files...";
	 	 if (status==FaxModem.ST_INIT_MODEM) lblStatus.Text="Initializing modem...";
	  	 if (status==FaxModem.ST_OPEN_PORT) lblStatus.Text="Opening port...";
	  	 if (status==FaxModem.ST_SEND_PAGE) lblStatus.Text="Sending page " + (int) (page +1);
         if (status==FaxModem.ST_REC_PAGE) lblStatus.Text="Receiving page " + (int) (page +1);
         if (status==FaxModem.ST_REC_CALL) lblStatus.Text="Call detected...";
         if (status==FaxModem.ST_WAIT_CALL) lblStatus.Text="Waiting for call...";
			
			
		}
		
		protected void sendfax() 
		{
			
		TextFaxProducer fp=new TextFaxProducer();
		
		fp.textFont= new Font(new FontFamily("Arial"),12);
		fp.text="";
		for (int i=0;i<textData.Lines.Length;i++) fp.text=fp.text+"\n"+textData.Lines[i];
			
		fp.prepare();
		
		FaxModem m=new FaxModem();	
		m.getEncoder().scaleFactor=2;
		m.getEncoder().centerImage=true;			
		m.flowControl=FaxModem.FLOWCONTROL_RTSCTS;
		m.ATFlowControlRTSCTS=this.comboFlowControlCommand.Text;
		m.setInitstring(textInit.Text);	
		m.directBitOrder=true;
	 	m.log=true;			
		m.resolution=FaxModem.RESOLUTION_NORMAL;
		m.bitRate=FaxModem.BITRATE_9600;
		m.AtFBOR=true;
			
		if (this.comboFlowControl.SelectedIndex==1) 
			{ m.flowControl=FaxModem.FLOWCONTROL_XONXOFF;
			  m.ATFlowControlXONXOFF=this.comboFlowControlCommand.Text;	
			}
		if (this.comboFlowControl.SelectedIndex==2) 
			{m.flowControl=FaxModem.FLOWCONTROL_NONE;
			m.ATFlowControlNone=this.comboFlowControlCommand.Text;
			}
		
		m.port=this.textPort.Text;
		m.dialTone=true;
		
		bool success=false;
		
		this.Cursor=Cursors.WaitCursor;
		
		if (m.open(fp)) {
			
 			if (m.sendFax(this.textNumber.Text)) {
			 success=true;
 			 this.lblStatus.ForeColor=Color.Blue;
			 this.lblStatus.Text="Fax successfully sent.";
			 }

	 		// set error text
			 if (!success) {
		  		 this.lblStatus.ForeColor=Color.Red;
		  		 this.lblStatus.Text="Error: " + m.lastError;
		   		if (m.hangCode>0) this.lblStatus.Text="Error: " + m.lastError + "(hang up code " + m.hangCode + ")";
	  		 }			
			
		}	
			
		m.close();
		
		try {

			FileStream fo= new FileStream("log.txt",FileMode.Create);
			char[] c=m.logStr.ToCharArray();
			for (int i=0;i<c.Length;i++)  fo.WriteByte((byte) c[i]);
			fo.Close();

		} catch (Exception e) {
			Console.WriteLine(e.Message);

		}	
		
		try {
			m=null;
		} catch (Exception e) {
			Console.WriteLine("Error disposing: " + e.Message);

		}		
		
		this.Cursor=Cursors.Default;
			
		}
		
  /**
   * Fax Receiver interface
   */
  public void faxReceived(String callerId, bool success,String file,int pages) {
      Console.WriteLine("");
      Console.WriteLine("Fax from " +callerId);
      Console.WriteLine("Success " +success);
      Console.WriteLine("File " +file);
      Console.WriteLine("");
      Console.WriteLine("");

      this.textData.Text="";
      this.textData.Text="Fax received from: " +callerId+"\n File: "+file+"\n Success: "+ success;
  }
		
		
	public static void Main(string[] args)
		{		
		 	
			Application.Run(new FaxTest());
		}		
		
	}

